<template>
    <div :style="Style" class="text-render-box">
        <div v-for="s in Points"
             class="text"
             :style="{
                top: s.Center[1] + '%',
                left: s.Center[0] + '%',
                fontSize: FontSize,
                color: color
             }"
        >
            {{ s.Name }}
        </div>
    </div>
</template>

<style lang='scss' scoped>
.text {
    position: absolute;
    transform: translate(-50%, -50%);
}

.text-render-box {
    position: absolute;
}
</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {ColoredFloorPlan, ColoredFloorPlanData} from "src/classLibrary/Geometry/Colored";
import {Point} from "src/classLibrary/Geometry/Point";

class KeyPoint {
    Center: Point;
    Name: string;

    constructor(Center: Point, Name: string) {
        this.Center = Center;
        this.Name = Name;
    }

}

@Component
export default class FloorPlanTextRender extends Vue {

    @Prop() width!: number;
    @Prop() height!: number;
    @Prop() coloredFloorPlan!: ColoredFloorPlanData;
    @Prop() fontSize!: number;
    @Prop() color!: string;


    get FontSize(): string {
        return this.fontSize + 'px';
    }

    get Points(): KeyPoint[] {
        if (this.coloredFloorPlan)
            return new ColoredFloorPlan(this.coloredFloorPlan).quads.Map(x => {
                    return new KeyPoint(
                        x.quad.Scale(100, 100).Center(),
                        x.name
                    )
                }
            )
        return [];

    }


    get Style() {
        return {
            width: this.width + 'px',
            height: this.height + 'px',
        }
    }
}
</script>
